# passgen.tcl v1.8 by domsen <domsen@domsen.org> (c)2oo2
#
# comments? bugs? ideas? plz mail me :)
#
# generates random passes with small letters, capital
# letters and numbers with a maximum length of 500 chars.
# this should be enough for everybody i think :)
#
# -n = numeric (numbers only)
# -s = small letters
# -c = capital letters
# -w = word (small + capital letters)
# -a = alphanumeric (numbers + small and capital letters)
# -m = mask ie aaaa-wwsc-nncs , -l will be ignored
#      a = alphanumeric
#      n = numeric
#      w = word
#      s = small letters
#      c = capital letters
# -l = password length
# usage: .passgen <length> -n / -w / -c / -s / -a / -m / -l 

# if no paramters given, these values will be used
set standard "-a"
set standardlength "8"

bind msg - .passgen msg_pwgen
bind pub - .passgen pub_pwgen

# dont change anything below

set gross {A B C D E F G H I J K L M N O P Q R S T U V W X Y Z}
set klein {a b c d e f g h i j k l m n o p q r s t u v w x y z}
set zahlen {0 1 2 3 4 5 6 7 8 9}
set passversion "v1.8"

proc do-a { length } {
global gross klein zahlen
set counter 0
set passwort ""
while {$counter < $length } { 
set onetwothree [rand 3]
if { $onetwothree == "0" } {
set neu [lindex $klein [rand [llength $klein]]]
}
if { $onetwothree == "1" } {
set neu [lindex $gross [rand [llength $gross]]]
}
if { $onetwothree == "2" } {
set neu [lindex $zahlen [rand [llength $zahlen]]]
}
set passwort "$passwort$neu"
incr counter
}
return $passwort
}

proc do-n { length } {
global zahlen
set counter 0
set passwort ""
while {$counter < $length } { 
set neu [lindex $zahlen [rand [llength $zahlen]]]
set passwort "$passwort$neu"
incr counter
}
return $passwort
}

proc do-w { length } {
global klein gross
set counter 0
set passwort ""
while {$counter < $length } { 
set onetwothree [rand 2]
if { $onetwothree == "0" } {
set neu [lindex $klein [rand [llength $klein]]]
}
if { $onetwothree == "1" } {
set neu [lindex $gross [rand [llength $gross]]]
}
set passwort "$passwort$neu"
incr counter
}
return $passwort
}

proc do-s { length } {
global klein
set counter 0
set passwort ""
while {$counter < $length } { 
set neu [lindex $klein [rand [llength $klein]]]
set passwort "$passwort$neu"
incr counter
}
return $passwort
}

proc do-c { length } {
global gross
set counter 0
set passwort ""
while {$counter < $length } { 
set neu [lindex $gross [rand [llength $gross]]]
set passwort "$passwort$neu"
incr counter
}
return $passwort
}

proc msg_pwgen {nick uhost hand arg} {
global standard standardlength 
set style ""
if { $arg == ""} {
set length $standardlength
set style $standard
}
if { $arg != "" } {
if {[lsearch -exact $arg "-l"] != -1 } {
set pos [expr ([lsearch -exact $arg "-l"] + 1)]
set length [lindex $arg $pos]
if { $length > 500 } {return 0}
}
if {[lsearch -exact $arg "-a"] != -1 } { set style "-a" }
if {[lsearch -exact $arg "-n"] != -1 } { set style "-n" }
if {[lsearch -exact $arg "-w"] != -1 } { set style "-w" }
if {[lsearch -exact $arg "-s"] != -1 } { set style "-s" }
if {[lsearch -exact $arg "-c"] != -1 } { set style "-c" }
if {[lsearch -exact $arg "-m"] != -1 } { set style "-m" }
if {$style == ""} { set style $standard }
}
if { $style == "-a" } { putserv "privmsg $nick :[do-a $length]" }
if { $style == "-n" } { putserv "privmsg $nick :[do-n $length]" }
if { $style == "-w" } { putserv "privmsg $nick :[do-w $length]" }
if { $style == "-s" } { putserv "privmsg $nick :[do-s $length]" }
if { $style == "-c" } { putserv "privmsg $nick :[do-c $length]" }

if { $style == "-m" } {
set password ""
set pos [expr ([lsearch -exact $arg "-m"] + 1)]
set mask [lindex $arg $pos]
set maske [split $mask {}]
foreach i $maske {
if {$i == "a"} { set password $password[do-a 1] } elseif {
$i == "n"} { set password $password[do-n 1] } elseif {
$i == "w"} { set password $password[do-w 1] } elseif {
$i == "s"} { set password $password[do-s 1] } elseif {
$i == "c"} { set password $password[do-c 1] } elseif {
$i == "-"} { set password $password- } else {
set password $password$i }
}
putserv "privmsg $nick :$password"
}
}



proc pub_pwgen {nick uhost hand chan arg} {
global standard standardlength 
set style ""
if { $arg == ""} {
set length $standardlength
set style $standard
}
if { $arg != "" } {
if {[lsearch -exact $arg "-l"] != -1 } {
set pos [expr ([lsearch -exact $arg "-l"] + 1)]
set length [lindex $arg $pos]
if { $length > 500 } {return 0}
}
if {[lsearch -exact $arg "-a"] != -1 } { set style "-a" }
if {[lsearch -exact $arg "-n"] != -1 } { set style "-n" }
if {[lsearch -exact $arg "-w"] != -1 } { set style "-w" }
if {[lsearch -exact $arg "-s"] != -1 } { set style "-s" }
if {[lsearch -exact $arg "-c"] != -1 } { set style "-c" }
if {[lsearch -exact $arg "-m"] != -1 } { set style "-m" }
if {$style == ""} { set style $standard }
}
if { $style == "-a" } { putserv "notice $nick :[do-a $length]" }
if { $style == "-n" } { putserv "notice $nick :[do-n $length]" }
if { $style == "-w" } { putserv "notice $nick :[do-w $length]" }
if { $style == "-s" } { putserv "notice $nick :[do-s $length]" }
if { $style == "-c" } { putserv "notice $nick :[do-c $length]" }

if { $style == "-m" } {
set password ""
set pos [expr ([lsearch -exact $arg "-m"] + 1)]
set mask [lindex $arg $pos]
set maske [split $mask {}]
foreach i $maske {
if {$i == "a"} { set password $password[do-a 1] } elseif {
$i == "n"} { set password $password[do-n 1] } elseif {
$i == "w"} { set password $password[do-w 1] } elseif {
$i == "s"} { set password $password[do-s 1] } elseif {
$i == "c"} { set password $password[do-c 1] } elseif {
$i == "-"} { set password $password- } else {
set password $password$i }
}
putserv "notice $nick :$password"
}
}

putlog "*** passgen.tcl $passversion by domsen succesfully loaded"

#[EOF]